   
Dim CodAtiv

' Codigo de ativao
CodAtiv = "123123123"

rem ***********************************************************************************************
rem ***********************************************************************************************

Dim LOG
Const ForReading=1, ForWriting=2, ForAppending=8

rem ***********************************************************************************************
rem ***********************************************************************************************
rem *******************************  Gravar Log do aplicativo *************************************
Function GravarLog (linha1, linha2, linha3, pula)
arquivo = "c:\sweda\SATscript-log-vb.txt"    
dim hand    
dim lin1, lin2
Set hand = LOG.OpenTextFile(arquivo, ForAppending, True)
lin1 = CStr(linha1)
lin2 = CStr(linha2)  
lin3 = CStr(linha3)
Dim linha
linha = lin1 & lin2 & lin3
If pula then 
   linha = linha & vbCrLf
 End If   
hand.Write (linha)
hand.Close
End Function
rem ******************************************** FIM **********************************************
rem ***********************************************************************************************
rem ***********************************************************************************************
rem ***********************************************************************************************


rem ***********************************************************************************************
rem ***********************************************************************************************
rem **************************** Incrementa nmero da sesso **************************************
rem Exemplo:  LPad(12345, 7, "0")
rem 0012345
Function LPad(s, l, c)
  Dim n : n = 0
  Dim r
  If l > Len(s) Then 
      n = l - Len(s)
      r = String(n, c) & s
  else
      r = ""   
  End If
  If Len(r) = 0 OR r = "000000" OR r = "999999" Then
      r = "000001" 
  End If
  LPad = r
End Function

rem ***********************************************************************************************
rem ***********************************************************************************************
rem ***********************************************************************************************
rem ***********************************************************************************************

Set LOG = CreateObject("Scripting.FileSystemObject")
Set CONSOLE = CreateObject ("Scripting.FileSystemObject")
Set stdout = CONSOLE.GetStandardStream (1)

If LOG.FolderExists ("\SWEDA") = False Then
   LOG.CreateFolder ("\SWEDA")
End If

' Chama dll SWEDA
rem -----------------------------------------------------------------------------------------------
set SATsw = CreateObject("SATscript.DLL.object")
rem -----------------------------------------------------------------------------------------------

call GravarLog ("inicio do log", "", "", True)

stdout.WriteLine "Iniciando Comunicacao com o SAT"

Dim nSessao, Fim, Args, resto
Dim XML, handxml, dados
Dim Caixa, PosIniXml, PosFimXml
Dim CnpjSwHouse
Dim SignSwHouse
Dim c_nSessao, sessaorx, erro, retorno, retorno_venda
Dim nn, PosIni, PosFim
Dim MErro
Dim CSefaz
Dim MSefaz
Dim timestamp
Dim Id
Dim total
Dim CPF, CNPJ, Codigo
Dim DadosCanc
Dim Doc

nSessao = "000000"

rem *************************** Consulta entre AC e Equipamento SAT *****************************************
rem Esta funo  usada para testes de comunicao entre o AC e o Equipamento SAT

stdout.WriteLine "Consultando o SAT... ConsultarSAT()"

nSessao = LPad(nSessao + 1, 6, "0")

'arg1 = Nmero aleatrio gerado pelo AC para controle da comunicao.
call GravarLog ("ConsultarSAT (", nSessao, ")", True)

rem ****************************************************************************************************    
retorno = SATsw.ConsultarSAT (nSessao)
rem ****************************************************************************************************    
stdout.WriteLine retorno
call GravarLog ("retorno ConsultarSAT = ",retorno,"",True)

rem *************************** Consulta do Status Operacional do Equipamento SAT ***************************
rem Essa funo  responsvel por verificar a situao de funcionamento do Equipamento SAT.

'arg1 = Nmero aleatrio gerado pelo AC para controle da comunicao.
'arg2 = Senha definida pelo contribuinte no software de ativao.

stdout.WriteLine "Consultando o SAT... ConsultarStatusOperacional()"

nSessao = LPad(nSessao + 1, 6, "0")

args = nSessao & "," & CodAtiv
call GravarLog ("ConsultarStatusOperacional (", args, ")", true)

rem ****************************************************************************************************    
retorno = SATsw.ConsultarStatusOperacional (nSessao, CodAtiv) 
rem ****************************************************************************************************    
stdout.WriteLine retorno
call GravarLog ("retorno ConsultarStatusOperacional = ",retorno, "", True)

rem ***************************************** VENDA ********************************************************

stdout.WriteLine "Enviando VENDA para o SAT... EnviarDadosVenda()"

' N O T A:
' O nmero de itens na venda deve ser menor que 500.
' O nmero de itens na venda deve ser menor que 500.
' O nmero de itens na venda deve ser menor que 500.
rem arqxml = "arquivo_dados.xml"
rem arqxml = "arquivo_dados498.xml"
rem arqxml = "dados-3.12.xml"
arqxml = "dados-3.15.xml"

' Leitura do arquivo contedo ANSI
Set XML = CreateObject("Scripting.FileSystemObject")
dim sScriptDir
sScriptDir = XML.GetParentFolderName(WScript.ScriptFullName)
Wscript.Echo "Diretorio do aplicativo = " & sScriptDir

Set handxml = XML.OpenTextFile(arqxml, ForReading)
If handxml.AtEndOfStream <> True then
   dados = handxml.ReadAll
End If
handxml.Close

rem Obtem o nmero do caixa da venda
PosIniXml = InStr(1,dados,"<numeroCaixa>")
if PosIniXml <> 0 Then
   PosIniXml = PosIniXml + 13 
   PosFimXml = InStr(PosIniXml,dados,"</numeroCaixa>")
   If PosFimXml <> 0 Then
     Caixa = Mid (dados, PosIniXml, PosFimXml - PosIniXml)
   End If  
End If
call GravarLog ("Nmero do Caixa = ", Caixa, "", true)

rem Obtem o CNPJ da software house

PosIniXml = InStr(1,dados,"<CNPJ>")
if PosIniXml <> 0 Then
   PosIniXml = PosIniXml + 6 
   PosFimXml = InStr(PosIniXml,dados,"</CNPJ>")
   If PosFimXml <> 0 Then
     CnpjSwHouse = Mid (dados, PosIniXml, PosFimXml - PosIniXml)
   End If  
End If
call GravarLog ("CNPJ da Software House = ", CnpjSwHouse, "", true)

rem Obtem a assinatura da Software House

PosIniXml = InStr(1,dados,"<signAC>")
if PosIniXml <> 0 Then
   PosIniXml = PosIniXml + 8 
   PosFimXml = InStr(PosIniXml,dados,"</signAC>")
   If PosFimXml <> 0 Then
      SignSwHouse  = Mid (dados, PosIniXml, PosFimXml - PosIniXml)
   End If  
End If
call GravarLog ("signAC Software House = ", SignSwHouse, "", true)

rem *********************************************************************************************************
rem **************************** Envio de dados da venda ****************************************************
rem O envio dos dados da venda do AC para o Equipamento SAT dever ser atravs da funo EnviarDadosVenda.
rem O tempo de resposta de um pedido de emisso de CF-e-SAT dever ser inferior a 1 segundo para cupom com at
rem 50 itens, inferior a 3 segundos para cupom que possui entre 51 e 200 itens e inferior a 5 segundos para
rem cupom que possui entre 201 e 500 itens. Tempo de resposta  a quantidade de segundos que o SAT demora para
rem gerar um CF-e-SAT aps a recepo das informaes do Aplicativo Comercial. A gerao do CF-e-SAT s  
rem considerada completa quando o Aplicativo Comercial recebe a cpia de segurana do documento.
rem **********************************************************************************************************


for i=1 to 3 Step 1
    nSessao = LPad(nSessao + 1, 6, "0")
    c_nSessao = nSessao
    args = nSessao & "," & CodAtiv & "," & dados
    call GravarLog ("EnviarDadosVenda (", args, ")", true)   

rem !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
rem ATENO: Opo 2: informar a path do arquivo xml ao invs do seu contedo no Arg3 (apenas na venda).
rem !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
rem    dados = ""
rem    dados = sScriptDir & "\" & arqxml


rem ****************************************************************************************************        
    retorno = SATsw.EnviarDadosVenda (nSessao, CodAtiv, dados) 
rem ****************************************************************************************************    
 
    call GravarLog ("retorno EnviarDadosVenda = ",retorno, "", True)
    retorno_venda = retorno
    stdout.WriteLine retorno

rem [[[[[[[[[ O registro retornado pelo SAT est gravado em UTF-8 no arquivo c:\SWEDA\RETORNO.TXT. ]]]]]]]]]
rem [[[[[[[[[ O string <retorno> acima retorna TAMBM os campos (menos a VENDA), mas em UNICODE.   ]]]]]]]]]
rem [[[[[[[[[ A venda no  retornada no string <retorno> porque se for muito grande pode gerar    ]]]]]]]]]
rem [[[[[[[[[ ERRO RUN TIME, ("ESPAO INSUFICIENTE DE ARMAZENAMENTO PARA PROCESSAR ESTE COMANDO"). ]]]]]]]]] 
rem [[[[[[[[[ Se contedo for invlido ou sem respota, string <retorno> ser vazio.                ]]]]]]]]]
rem [[[[[[[[[ O CFe recebido em base64 foi decodificado e gravado em UTF-8 em c:\SWEDA\CFe.xml.    ]]]]]]]]]
rem [[[[[[[[[ Aplicativo deve renomear arquivo com prefixo "AD" + chave de consulta e extenso 'xml'. ]]]]]]]]]
rem [[[[[[[[[ Exemplo:  AD35160153485215000106599000016520116171179358.xml                        ]]]]]]]]]

    If Len(retorno) > 15 Then
       sessaorx = Mid (retorno, 1, 6)
       erro = Mid (retorno, 8, 5)
       if erro = "06000" AND sessaorx = c_nSessao Then
          call GravarLog ("<<< Veio a venda de contingencia!!!!!! >>>", "", "", true)           
          stdout.WriteLine "<<< Veio a venda de contingencia!!!!!! >>>"          
          Exit For
       End If
    End If

rem Nao veio a venda de contingencia. Ou foi devido  falha de recepo ou a venda no foi recebida no SAT.

rem *************************** Comando de Consulta do nmero de sesso *************************************
rem O AC poder verificar se a ltima sesso requisitada foi processada em caso de no recebimento do retorno 
rem da operao. O equipamento SAT-CF-e retornar exatamente o resultado da sesso consultada.

'arg1 = Nmero aleatrio gerado pelo AC para controle da comunicao.
'arg2 = Senha definida pelo contribuinte no software de ativao.
'arg3 = Nmero de sesso a ser consultado no SAT-CF-e.

    stdout.WriteLine "ConsultarNumeroSessao()"

    nSessao = LPad(nSessao + 1, 6, "0")
    args = nSessao & "," & CodAtiv & "," & c_nSessao
    call GravarLog ("ConsultarNumeroSessao (", args, ")", true)

rem ****************************************************************************************************        
    retorno = SATsw.ConsultarNumeroSessao (_
                   nSessao,_ 
                   CodAtiv,_
                   c_nSessao)
rem ****************************************************************************************************    

    call GravarLog ("retorno ConsultarNumeroSessao = ",retorno, "", True)
    stdout.WriteLine retorno

    if Len(retorno) > 6 Then
       sessaorx = Mid (retorno, 1, 6)
       erro = Mid (retorno, 8, 5)
       if erro = "06000" AND sessaorx =  c_nSessao Then
          call GravarLog ("<<< Venda contingencia recuperada do SAT via consulta de sessao - OK!!!!!! >>>","","",true)
          stdout.WriteLine "<<< Venda contingencia recuperada do SAT via consulta de sessao - OK!!!!!! >>>"
          Exit For
       End If
    End If

' Se continua vindo erro - abandona sem retransmitir para no ter risco de duplicar (ver exceo erro 11003).    

' Houve erro (diferente de 4000,5000,6000...    ?
' Se for <secao no existe> assume que SAT no recebeu a venda
   resto = CLng(erro) Mod 1000
   if resto <> 0 AND erro <> "11003" Then
        call GravarLog ("******* FALHA de comunicao com o SAT!","","",True)
        stdout.WriteLine "******* FALHA de comunicacao com o SAT!" 
        stdout.WriteLine "<<<<<<< Atraves da funcao ExtrairLog(...) pode ser obtida a causa do erro >>>>>>>"
        call GravarLog ("<<<<<<< Atraves da funcao ExtrairLog(...) pode ser obtida a causa do erro >>>>>>>","","",True)        
        retorno_venda = ""
        Exit For
   End If        

' Tenta retransmitir a venda porque SAT no recebeu a venda atual enviada.
   if i <> 3 then
      call GravarLog ("******* Retransmite a venda novamente porque SAT no tinha recebido CFe atual","","",true)
      stdout.WriteLine "******* Retransmite a venda novamente porque SAT no tinha recebido CFe atual"      
   else
      call GravarLog ("******* ERRO - Envio da VENDA  NO realizada!","","",true)
      stdout.WriteLine "******* ERRO - Envio da VENDA  NO realizada!"
      retorno_venda = ""

      stdout.WriteLine "<<<<<<< Atraves da funcao ExtrairLog(...) pode ser obtida a causa do erro >>>>>>>"
      call GravarLog ("<<<<<<< Atraves da funcao ExtrairLog(...) pode ser obtida a causa do erro >>>>>>>","","",True)        
   End If   
Next

stdout.WriteLine "Logando dados de retorno da venda"

 MErro = ""
CSefaz = ""
MSefaz = ""
timestamp = ""
Id = ""
Total = ""
CNPJ = ""
CPF = ""

If Len(retorno_venda) > 0 Then
    PosIni = 0
    nn = 1
    Fim = 0
    Do while Fim = 0  AND nn < 12
        PosIni = PosIni + 1         
        PosFim = InStr(PosIni,retorno_venda,"|")
        if PosFim = 0 Then
           PosFim = Len(retorno_venda)
           Fim = 1          
        End If           
        if (PosFim-PosIni) >= 1 Then
           Select Case nn
              Case 4	
                  MErro = Mid (retorno_venda, PosIni, PosFim - PosIni)
              Case 5
                  CSefaz = Mid (retorno_venda, PosIni, PosFim - PosIni)
              Case 6
                  MSefaz = Mid (retorno_venda, PosIni, PosFim - PosIni)
              Case 8
                  timestamp = Mid (retorno_venda, PosIni, PosFim - PosIni)
              Case 9
                  Id = Mid (retorno_venda, PosIni, PosFim - PosIni)
              Case 10	
                  total = Mid (retorno_venda, PosIni, PosFim - PosIni)
              Case 11
                  Codigo = Mid (retorno_venda, PosIni, PosFim - PosIni)
                  if Len(Codigo) > 11 Then
                     CNPJ = Codigo
                  else
                     CPF  = Codigo
                 End If   
          End Select
       End If                
       nn = nn + 1
       PosIni = PosFim
    Loop
call GravarLog ("Mensagem de Erro = ", MErro,"",true)
call GravarLog ("Codigo SEFAZ     = ", CSefaz,"",true)
call GravarLog ("Mensagem SEFAZ   = ", MSefaz,"",true)
call GravarLog ("TIME STAMP       = ", timestamp,"",true)
call GravarLog ("Chave de Consulta= ", Id,"",true)

stdout.WriteLine "Chave de Consulta= " & Id

call GravarLog ("Total            = ", total,"",true)
call GravarLog ("C N P J          = ", CNPJ,"",true)
call GravarLog ("C P F            = ", CPF,"",true)  
End If



