 
rem ***********************************************************************************************
rem ***********************************************************************************************

Const ForReading=1, ForWriting=2, ForAppending=8

Set CONSOLE = CreateObject ("Scripting.FileSystemObject")
Set stdout = CONSOLE.GetStandardStream (1)
Set stdin  = CONSOLE.GetStandardStream (0)

Dim Retorno

rem *********************************************************************************************************
rem *********************************************************************************************************
rem ***********************************  Imprimir Texto Digitado  *******************************************
Function ImprimeLinhaTexto()
Dim Linha    
stdout.WriteLine "Digite o texto a ser impresso:"
Linha = ""
Do While Not WScript.StdIn.AtEndOfLine
   Linha = Linha & WScript.StdIn.Read(1)
Loop    
rem ****************************************************************************************************    
Retorno = SATsw.ImprimeTexto_SI300 (Linha & vbCrLf & vbCrLf & vbCrLf & vbCrLf & vbCrLf & vbCrLf)
rem ****************************************************************************************************    
stdout.WriteLine "ImprimeTexto_SI300 (" & Linha &  " & vbCrLf) -> " & Retorno
WScript.StdIn.ReadLine
End Function

rem *********************************************************************************************************
rem *********************************************************************************************************
rem ************************************ Imprimir Arquivo de Texto ******************************************
Function ImprimeArquivoTexto()
stdout.WriteLine "Imprimindo arquivo <TEF.txt>"
rem ****************************************************************************************************    
Retorno = SATsw.ImprimeTexto_SI300 ("TEF.txt")
rem ****************************************************************************************************    
stdout.WriteLine "ImprimeTexto_SI300 ('TEF.txt') -> " & Retorno
Retorno = SATsw.ImprimeTexto_SI300 (vbCrLf & vbCrLf & vbCrLf & vbCrLf & vbCrLf & vbCrLf)
End Function

rem *********************************************************************************************************
rem *********************************************************************************************************
rem ***************************************** Imprime Imagem  ***********************************************

Function ImprimeImagem()  
stdout.WriteLine "Imprime Imagem PRETO e BRANCO"
rem "<<<<<<<<<<<< IMPRIMIR IMAGEM >>>>>>>>>>>>>>>>>>>>"
rem "= 1 = imprimir imagens (.bmp) monocromticas, ou seja, imprime usando apenas a cor preta, gerando "
rem "      uma imagem preta/branca."
rem ****************************************************************************************************    
Retorno = SATsw.ImprimeImagem_SI300 ("1", "flecha.bmp")
rem ****************************************************************************************************    
stdout.WriteLine "ImprimeImagem_SI300 (1, flecha.bmp) -> " & Retorno

stdout.WriteLine "Imprime Imagem em tons de CINZA"
rem "= 0 = imprimir imagens (.bmp) em tons de cinza, ou seja, imprime a imagem em varias intensidades "
rem "      diferentes de cinza."
rem ****************************************************************************************************    
Retorno = SATsw.ImprimeImagem_SI300 ("0", "flecha.bmp")
rem ****************************************************************************************************    
stdout.WriteLine "ImprimeImagem_SI300 (0, flecha.bmp) -> " & Retorno
Retorno = SATsw.ImprimeTexto_SI300 (vbCrLf & vbCrLf & vbCrLf & vbCrLf & vbCrLf & vbCrLf)
End Function

rem *********************************************************************************************************
rem *********************************************************************************************************
rem ***************************************** Imprime DANFE  ************************************************
Function ImprimeDANFE()
Dim tipo
stdout.WriteLine "I m p r i m e    D A N F E     R E S U M O  (S/N)?"
tipo = WScript.StdIn.Read(1)   
If tipo = "S" Or  tipo = "s" then 
    Retorno = SATsw.GeraResumoXML_SI300
    stdout.WriteLine "<<< Imprime DANFE RESUMO >>>"
    stdout.WriteLine "GeraResumoXML_SI300 -> " & Retorno
Else    
    stdout.WriteLine "Imprime DANFE COMPLETO - via do consumidor"    
End If
rem ****************************************************************************************************    
Retorno = SATsw.ImprimeXML_SI300("NFCe-enviada.xml")
rem ****************************************************************************************************    
stdout.WriteLine "ImprimeXML_SI300('NFCe-enviada.xml') -> " &  Retorno
WScript.StdIn.ReadLine
End Function

rem *********************************************************************************************************
rem *********************************************************************************************************
rem ************************************* Imprime DANFE Contingencia ****************************************
Function ImprimeDANFEContingencia()
stdout.WriteLine "Imprime    tambem   D A N F E   VIA ESTABELECIMENTO  (S/N)?"
tipo = WScript.StdIn.Read(1)   
If tipo = "S" Or  tipo = "s" then 
    Retorno = SATsw.ViaLojaConsumidorXML_SI300
    stdout.WriteLine "<<< Imprimira  DANFE COMPLETO CONTINGENCIA via ESTABELECIMENTO >>>"
    stdout.WriteLine "ViaLojaConsumidorXML_SI300 -> " & Retorno
Else    
    stdout.WriteLine "<<< Imprime DANFE COMPLETO - CONTINGENCIA - apenas via CONSUMIDOR >>>"    
End If   

stdout.WriteLine "Informa total recebido (1000.00) para calculo do troco no proximo DANFE (NFCE)"
Retorno = SATsw.ValorPagoXML_SI300 ("1000.00")
stdout.WriteLine "ValorPagoXML_SI300 ('1000.00') -> " & Retorno

rem ****************************************************************************************************    
Retorno = SATsw.ImprimeXML_SI300("NFCe-contingencia.xml")
rem ****************************************************************************************************    
stdout.WriteLine "ImprimeXML_SI300('NFCe-contingencia.xml') -> " &  Retorno   
WScript.StdIn.ReadLine
End Function


rem *********************************************************************************************************
rem *********************************************************************************************************
rem ******************************** Imprime Extrato do SAT *************************************************
Function ImprimeExtratoSAT()
Dim tipo
stdout.WriteLine "I m p r i m e     E X T R A T O     R E S U M O  (S/N)?"
tipo = WScript.StdIn.Read(1)   
If tipo = "S" Or  tipo = "s" then 
    Retorno = SATsw.GeraResumoXML_SI300
    stdout.WriteLine "<<< Imprime EXTRATO do SAT RESUMO >>>"
    stdout.WriteLine "SATsw.GeraResumoXML_SI300 -> " & Retorno
Else    
    stdout.WriteLine "Imprime EXTRATO do SAT COMPLETO"    
End If   

rem ****************************************************************************************************    
Retorno = SATsw.ImprimeXML_SI300("CFe.xml")
rem ****************************************************************************************************    
stdout.WriteLine "SATsw.ImprimeXML_SI300('CFe.xml') -> " &  Retorno  
WScript.StdIn.ReadLine
End Function

rem *********************************************************************************************************
rem *********************************************************************************************************
rem ******************************************* Aciona Gaveta  **********************************************

Function AcionaGaveta()
stdout.WriteLine "Abre a Gaveta"
rem ****************************************************************************************************    
Retorno = SATsw.AcionaGaveta_SI300
rem ****************************************************************************************************    
stdout.WriteLine "AcionaGaveta_SI300 -> " & Retorno

rem ****************************************************************************************************    
Retorno = SATsw.StatusGaveta_SI300
rem ****************************************************************************************************    
stdout.WriteLine "StatusGaveta_SI300 = " & Retorno
End Function

rem *********************************************************************************************************
rem *********************************************************************************************************
rem ********************************************* Status ****************************************************
Function StatusSI300()

rem "?????????????????    S T A T U S   ???????????????????????????"
rem "ndice       Retorno 0                     Retorno 1 "
rem "1    Impressora operacional        Impressora em falha" 
rem "2    Off Line                      On Line "
rem "3    Papel OK                      Fim de papel "
rem "4    Guilhotina no detectada      Guilhotina detectada "
rem "5    Tampa trmica fechada         Tampa trmica aberta "
rem "6    Sem papel sobre o sensor      Papel posicionado sobre o sensor "
rem "7    Gaveta fechada                Gaveta aberta. "
rem "8    Cheque inserido               SEM CHEQUE." 

Dim Oper
Oper = Array("Operacional", "falha")
Dim Off
Off  = Array("OFF LINE", "ON LINE")
Dim PapE
PapE = Array("Papel OK", "FIM de PAPEL")
Dim Guil
Guil = Array("SEM Guilhotina", "COM Guilhotina")
Dim Tamp
Tamp = Array("Tampa", "SEM tampa")
Dim NearE
NearE = Array("PAPEL ACABANDO","NEAR END OK")
Dim Gav
Gav  = Array("GAVETA FECHADA", "GAVETA ABERTA")
Dim Cheq
Cheq = Array("CHEQUE INSERIDO", "SEM CHEQUE")

rem ****************************************************************************************************    
rem  
Retorno = SATsw.Status_SI300 ("1")  
stdout.WriteLine "Status_SI300 ('1') --> Operacional?    = " & Retorno & " => " & Oper(Asc(Mid(Retorno,1,1)) And 1)
Retorno = SATsw.Status_SI300 ("2")  
stdout.WriteLine "Status_SI300 ('2') --> ON/OFF?         = " & Retorno & " => " & Off(Asc(Mid(Retorno,1,1)) And 1)
Retorno = SATsw.Status_SI300 ("3")  
stdout.WriteLine "Status_SI300 ('3') --> FIM Papel?      = " & Retorno & " => " & Pape(Asc(Mid(Retorno,1,1)) And 1)
Retorno = SATsw.Status_SI300 ("4")  
stdout.WriteLine "Status_SI300 ('4') --> Guilhotina?     = " & Retorno & " => " & Guil(Asc(Mid(Retorno,1,1)) And 1)
Retorno = SATsw.Status_SI300 ("5")  
stdout.WriteLine "Status_SI300 ('5') --> Tampa?          = " & Retorno & " => " & Tamp(Asc(Mid(Retorno,1,1)) And 1)
Retorno = SATsw.Status_SI300 ("6")  
stdout.WriteLine "Status_SI300 ('6') --> Papel acabando? = " & Retorno & " => " & NearE(Asc(Mid(Retorno,1,1)) And 1)
Retorno = SATsw.Status_SI300 ("7")  
stdout.WriteLine "Status_SI300 ('7') --> Gaveta?         = " & Retorno & " => " & Gav(Asc(Mid(Retorno,1,1)) And 1)
Retorno = SATsw.Status_SI300 ("8")  
stdout.WriteLine "Status_SI300 ('8') --> Cheque inserido? = " & Retorno & " => " & Cheq(Asc(Mid(Retorno,1,1)) And 1)
rem ****************************************************************************************************    
End Function

rem *********************************************************************************************************
rem *********************************************************************************************************
rem *************************************** Imprime Cheque  *************************************************
Function ImprimeCheque()
stdout.WriteLine "Imprime Cheque..."
Dim leiaute
Set leiaute = "134067031061008056009049115041156013012175004"
rem ****************************************************************************************************    
Retorno = SATsw.ImprimeCheque_SI300 (leiaute,"1,99","JOS AUGUSTO","SO PAULO","03/05/2016","")
rem ****************************************************************************************************    
stdout.WriteLine "ImprimeCheque_SI300 (leiaute,'1,99','JOS AUGUSTO','SO PAULO','03/05/2016','') -> " & Retorno
End Function

rem ***********************************************************************************************
rem ***********************************************************************************************
rem ***********************************************************************************************
rem ***********************************************************************************************

' Chama dll SWEDA
rem -----------------------------------------------------------------------------------------------
set SATsw = CreateObject("SATscript.DLL.object")
rem -----------------------------------------------------------------------------------------------

rem "Informa cld e CSC se for NFCe."
Retorno = SATsw.Inicia_Printer_SI300("000001","abc1234567890defghij1234567890klmnop")

Dim opcao
    opcao = "1"
    Do while Len(opcao) > 0 
        stdout.WriteLine " "
        stdout.WriteLine " "
        stdout.WriteLine "1. Imprime linha de Texto"
        stdout.WriteLine "2. Imprime Arquivo de Texto"
        stdout.WriteLine "3. Imprime Imagem"
        stdout.WriteLine "4. DANFE"
        stdout.WriteLine "5. DANFE Contingncia"
        stdout.WriteLine "6. EXTRATO do SAT"
        stdout.WriteLine "7. Imprime Cheque"
        stdout.WriteLine "8. Aciona Gaveta"
        stdout.WriteLine "9. Status"
        stdout.WriteLine "Q. Sair"                
        stdout.WriteLine " "
        stdout.WriteLine "opcao: "
        opcao = WScript.StdIn.ReadLine()
        Select Case opcao
            Case "1"
                call ImprimeLinhaTexto
            Case "2"    
                call ImprimeArquivoTexto           
            Case "3"                
                call ImprimeImagem
            Case "4"    
                call ImprimeDANFE
            Case "5"                
                call ImprimeDANFEContingencia
            Case "6"
                call ImprimeExtratoSAT
            Case "7"    
                call ImprimeCheque          
            Case "8"                
                call AcionaGaveta
            Case "9"    
                call StatusSI300               
            Case "q"    
                Exit Do               
            Case "Q"    
                Exit Do
            Case else
                stdout.WriteLine "opcao incorreta"
                stdout.WriteLine opcao
                opcao = "1"
        End Select
     Loop




