  
Dim CodAtiv, Args, retorno

' Codigo de ativao
CodAtiv = "123123123"


Dim nSessao
nSessao = "000000"

rem ***********************************************************************************************
rem ***********************************************************************************************

Dim LOG
Const ForReading=1, ForWriting=2, ForAppending=8

rem ***********************************************************************************************
rem ***********************************************************************************************
rem *******************************  Gravar Log do aplicativo *************************************
Function GravarLog (linha1, linha2, linha3, pula)
arquivo = "c:\sweda\Diversos-log-vb.txt"    
dim hand    
dim lin1, lin2
Set hand = LOG.OpenTextFile(arquivo, ForAppending, True)
 lin1 = CStr(linha1)
lin2 = CStr(linha2)  
lin3 = CStr(linha3)
Dim linha
linha = lin1 & lin2 & lin3
If pula then 
   linha = linha & vbCrLf
 End If   
hand.Write (linha)
hand.Close
End Function
rem ******************************************** FIM **********************************************
rem ***********************************************************************************************
rem ***********************************************************************************************
rem ***********************************************************************************************


rem ***********************************************************************************************
rem ***********************************************************************************************
rem **************************** Incrementa nmero da sesso **************************************
rem Exemplo:  LPad(12345, 7, "0")
rem 0012345
Function LPad(s, l, c)
  Dim n : n = 0
  Dim r
  If l > Len(s) Then 
      n = l - Len(s)
      r = String(n, c) & s
  else
      r = ""   
  End If
  If Len(r) = 0 OR r = "000000" OR r = "999999" Then
      r = "000001" 
  End If
  LPad = r
End Function


rem *********************************************************************************************************
rem *********************************************************************************************************
rem ***************************************** Ativar SAT ****************************************************
Function AtivarSAT()
stdout.WriteLine "AtivarSAT()"
nSessao = LPad(nSessao + 1, 6, "0")
'arg1 = Nmero aleatrio gerado pelo AC para controle da comunicao.
'arg3 = Foi usado um cdigo de ativao invlido.
args = nSessao & "," & "1,"  & "987654,"  & "53485215000106," & "35"
call GravarLog ("AtivarSAT (", args, ")", True)
stdout.WriteLine "AtivarSAT (" & args & ")"
rem ****************************************************************************************************    
retorno = SATsw.AtivarSAT (nSessao,"1","987654", "53485215000106", "35")
rem ****************************************************************************************************    
If Len(retorno) = 0 Then
    stdout.WriteLine "ERRO - NAO VEIO RETORNO DO SAT"
End If
stdout.WriteLine retorno
call GravarLog ("retorno AtivarSAT = ",retorno,"",True)
End Function

rem *********************************************************************************************************
rem *********************************************************************************************************
rem ********************************** Comunicar Certificado ICP Brasil *************************************
Function ComunicarCertificadoICPBrasil()
stdout.WriteLine "ComunicarCertificadoICPBrasil()"
nSessao = LPad(nSessao + 1, 6, "0")
'arg1 = Nmero aleatrio gerado pelo AC para controle da comunicao.
'arg2 = Foi usado um cdigo de ativao invlido.
args = nSessao & "," & "987654,"  & "certificado digital"
stdout.WriteLine "ComunicarCertificadoICPBrasil (" & args & ")"
call GravarLog ("ComunicarCertificadoICPBrasil (", args, ")", True)
rem ****************************************************************************************************    
retorno = SATsw.ComunicarCertificadoICPBrasil (nSessao,"987654", "certificado digital")
rem ****************************************************************************************************    
If Len(retorno) = 0 Then
    stdout.WriteLine "ERRO - NAO VEIO RETORNO DO SAT"
End If
stdout.WriteLine retorno
call GravarLog ("retorno ComunicarCertificadoICPBrasil = ",retorno,"",True)
End Function

rem *********************************************************************************************************
rem *********************************************************************************************************
rem ***************************************** Bloquear SAT  *************************************************

Function BloquearSAT()
stdout.WriteLine "BloquearSAT()"
nSessao = LPad(nSessao + 1, 6, "0")

'arg1 = Nmero aleatrio gerado pelo AC para controle da comunicao.
'arg2 = cdigo de ativao invlido para no bloquear.
args = nSessao & "," & "123123123" 
stdout.WriteLine "BloquearSAT (" & args & ")"
call GravarLog ("BloquearSAT (", args, ")", True)
stdout.WriteLine "Aguarde..."
rem ****************************************************************************************************    
retorno = SATsw.BloquearSAT (nSessao,"123123123")
rem ****************************************************************************************************    
If Len(retorno) = 0 Then
    stdout.WriteLine "ERRO - NAO VEIO RETORNO DO SAT"
End If
stdout.WriteLine retorno
call GravarLog ("retorno BloquearSAT = ",retorno,"",True)
End Function

rem *********************************************************************************************************
rem *********************************************************************************************************
rem *************************************** Desbloquear SAT  ************************************************
Function DesbloquearSAT()
stdout.WriteLine "DesbloquearSAT()"
nSessao = LPad(nSessao + 1, 6, "0")
'arg1 = Nmero aleatrio gerado pelo AC para controle da comunicao.
args = nSessao & "," & CodAtiv 
stdout.WriteLine "DesbloquearSAT (" & args & ")"
call GravarLog ("DesbloquearSAT (", args, ")", True)
rem ****************************************************************************************************    
retorno = SATsw.DesbloquearSAT (nSessao,CodAtiv)
rem ****************************************************************************************************    
If Len(retorno) = 0 Then
    stdout.WriteLine "ERRO - NAO VEIO RETORNO DO SAT"
End If
stdout.WriteLine retorno
call GravarLog ("retorno DesbloquearSAT = ",retorno,"",True)
End Function

rem *********************************************************************************************************
rem *********************************************************************************************************
rem *************************************** Extrair Logs ****************************************************
Function ExtrairLogs()
stdout.WriteLine "ExtrairLogs()"
nSessao = LPad(nSessao + 1, 6, "0")
'arg1 = Nmero aleatrio gerado pelo AC para controle da comunicao.
args = nSessao & "," & CodAtiv 
stdout.WriteLine "ExtrairLogs (" & args & ")"
call GravarLog ("ExtrairLogs (", args, ")", True)
rem ****************************************************************************************************    
retorno = SATsw.ExtrairLogs (nSessao,CodAtiv)
rem ****************************************************************************************************    

dim erro
erro = Mid (retorno, 8, 5)

if erro <> 15000 then
args = nSessao & "," & "00000000" 
stdout.WriteLine "ExtrairLogs (" & args & ")"
call GravarLog ("ExtrairLogs (", args, ")", True)
rem ****************************************************************************************************    
retorno = SATsw.ExtrairLogs (nSessao, "00000000")
rem ****************************************************************************************************    
End If

rem Arquivo LOG gerado em "c:\\SWEDA\\SATLOG.txt\" em UTF-8 (base64 decodificada).

If Len(retorno) = 0 Then
    stdout.WriteLine "ERRO - NAO VEIO RETORNO DO SAT"
End If
stdout.WriteLine retorno
call GravarLog ("retorno ExtrairLogs = ",retorno,"",True)
End Function


rem *********************************************************************************************************
rem *********************************************************************************************************
rem ******************************** Associar Assinatura ****************************************************
Function AssociarAssinatura()
stdout.WriteLine "AssociarAssinatura()"
nSessao = LPad(nSessao + 1, 6, "0")
'arg1 = Nmero aleatrio gerado pelo AC para controle da comunicao.
'arg2 = Informado um cdigo de ativao invlido.
Dim AssinaturaCNPJ
AssinaturaCNPJ = "Assinatura digital conjunto CNPJ Software House + CNPJ do estabelecimento comercial"
args = nSessao & "," & "987654," & "53485215000106," & AssinaturaCNPJ 
call GravarLog ("AssociarAssinatura (", args, ")", True)
stdout.WriteLine "AssociarAssinatura (" & args & ")"
rem ****************************************************************************************************    
retorno = SATsw.AssociarAssinatura (nSessao,"987654", "53485215000106", AssinaturaCNPJ)
rem ****************************************************************************************************    
If Len(retorno) = 0 Then
    stdout.WriteLine "ERRO - NAO VEIO RETORNO DO SAT"
End If
stdout.WriteLine retorno
call GravarLog ("retorno AssociarAssinatura  = ",retorno,"",True)
End Function

rem *********************************************************************************************************
rem *********************************************************************************************************
rem *************************************** AtualizarSoftwareSAT  *******************************************

Function AtualizarSoftwareSAT()
stdout.WriteLine "AtualizarSoftwareSAT()"
nSessao = LPad(nSessao + 1, 6, "0")
'arg1 = Nmero aleatrio gerado pelo AC para controle da comunicao.
'arg2 = cdigo de ativao invlido para no bloquear.
args = nSessao & "," & "123123123" 
call GravarLog ("AtualizarSoftwareSAT (", args, ")", True)
stdout.WriteLine "AtualizarSoftwareSAT (" & args & ")"
stdout.WriteLine "Aguarde..."
rem ****************************************************************************************************    
retorno = SATsw.AtualizarSoftwareSAT (nSessao,"123123123")
rem ****************************************************************************************************    
If Len(retorno) = 0 Then
    stdout.WriteLine "ERRO - NAO VEIO RETORNO DO SAT"
End If
stdout.WriteLine retorno
call GravarLog ("retorno AtualizarSoftwareSAT = ",retorno,"",True)
End Function

rem *********************************************************************************************************
rem *********************************************************************************************************
rem *********************************** ConfigurarInterfaceDeRede  ******************************************
Function ConfigurarInterfaceDeRede()
stdout.WriteLine "ConfigurarInterfaceDeRede()"
nSessao = LPad(nSessao + 1, 6, "0")
'arg1 = Nmero aleatrio gerado pelo AC para controle da comunicao.
'arg2 = cdigo de ativao invlido para no bloquear.

Dim DadosConfig

' exemplo do manual "Projeto SAT-CFe".
DadosConfig = "<config>"
DadosConfig = DadosConfig & "<tipoInter>ETHE<tipoInter>"
DadosConfig = DadosConfig & "<SSID>Nome da rede sem Fio</SSID>"
DadosConfig = DadosConfig & "<seg>NONE</seg>"
DadosConfig = DadosConfig & "<codigo>frase_ou_chave_de_acesso</codigo>"
DadosConfig = DadosConfig & "<tipoLan>IPFIX</tipoLan>"
DadosConfig = DadosConfig & "<lanIP>192.168.010.100</lanIP>"
DadosConfig = DadosConfig & "<lanMask>255.255.255.000</lanMask>"
DadosConfig = DadosConfig & "<lanGW>192.168.010.001</lanGW>"
DadosConfig = DadosConfig & "<lanDNS1>192.168.010.001</lanDNS1>"
DadosConfig = DadosConfig & "<lanDNS2>192.168.010.001</lanDNS2>"
DadosConfig = DadosConfig & "<usuario>usuario123</usuario>"
DadosConfig = DadosConfig & "<senha>***********</senha>"
DadosConfig = DadosConfig & "<proxy>0</proxy>"
DadosConfig = DadosConfig & "<proxy _ip>192.168.010.001</proxy _ip>"
DadosConfig = DadosConfig & "<proxy_porta>3128</proxy_porta>"
DadosConfig = DadosConfig & "<proxy_user>admin</proxy_user>"
DadosConfig = DadosConfig & "<proxy_senha>senha123456</proxy_senha>"
DadosConfig = DadosConfig & "</config>"

args = nSessao & "," & "987654," & DadosConfig
call GravarLog ("ConfigurarInterfaceDeRede (", args, ")", True)
stdout.WriteLine "ConfigurarInterfaceDeRede (" & args & ")"
stdout.WriteLine "Aguarde..."
rem ****************************************************************************************************    
retorno = SATsw.ConfigurarInterfaceDeRede (nSessao,"987654",DadosConfig)
rem ****************************************************************************************************    
If Len(retorno) = 0 Then
    stdout.WriteLine "ERRO - NAO VEIO RETORNO DO SAT"
End If
stdout.WriteLine retorno
call GravarLog ("retorno ConfigurarInterfaceDeRede = ",retorno,"",True)
End Function

rem *********************************************************************************************************
rem *********************************************************************************************************
rem ************************************ TrocarCodigoDeAtivacao  ********************************************
Function TrocarCodigoDeAtivacao()
stdout.WriteLine "TrocarCodigoDeAtivacao()"
nSessao = LPad(nSessao + 1, 6, "0")
'arg1 = Nmero aleatrio gerado pelo AC para controle da comunicao.
'arg2 = cdigos de ativao invlidos para dar erro.
args = nSessao & "," & "987654," & "1," & "987987," & "998877"
call GravarLog ("TrocarCodigoDeAtivacao (", args, ")", True)
stdout.WriteLine "Aguarde..."
rem ****************************************************************************************************    
retorno = SATsw.TrocarCodigoDeAtivacao (nSessao,"987654","1","987987","998877")
rem ****************************************************************************************************    
If Len(retorno) = 0 Then
    stdout.WriteLine "ERRO - NAO VEIO RETORNO DO SAT"
End If
stdout.WriteLine retorno
call GravarLog ("retorno TrocarCodigoDeAtivacao = ",retorno,"",True)
End Function

rem ***********************************************************************************************
rem ***********************************************************************************************
rem ***********************************************************************************************
rem ***********************************************************************************************

Set LOG = CreateObject("Scripting.FileSystemObject")
Set CONSOLE = CreateObject ("Scripting.FileSystemObject")
Set stdout = CONSOLE.GetStandardStream (1)
Set stdin  = CONSOLE.GetStandardStream (0)

If LOG.FolderExists ("\sweda") = False Then
   LOG.CreateFolder ("\sweda")
End If

' Chama dll SWEDA
rem -----------------------------------------------------------------------------------------------
set SATsw = CreateObject("SATscript.DLL.object")
rem -----------------------------------------------------------------------------------------------

call GravarLog ("inicio do log", "", "", True)


Dim opcao
    opcao = "1"
    Do while Len(opcao) > 0 
        stdout.WriteLine " "
        stdout.WriteLine " "
        stdout.WriteLine "1. Ativar SAT"
        stdout.WriteLine "2. Comunicar Certificado ICP Brasil"
        stdout.WriteLine "3. Bloquear SAT"
        stdout.WriteLine "4. Desbloquear SAT"
        stdout.WriteLine "5. Extrair Logs do SAT"
        stdout.WriteLine "6. Associar assinatura"
        stdout.WriteLine "7. Atualizar Software do SAT"
        stdout.WriteLine "8. Configurar Interface de Rede"
        stdout.WriteLine "9. Trocar Codigo de Ativao"
        stdout.WriteLine "Q. Sair"                
        stdout.WriteLine " "
        stdout.WriteLine "opcao: "
        opcao = WScript.StdIn.ReadLine()
        Select Case opcao
            Case "1"
                call AtivarSAT
            Case "2"    
                call ComunicarCertificadoICPBrasil           
            Case "3"                
                call BloquearSAT
            Case "4"    
                call DesBloquearSAT
            Case "5"                
                call ExtrairLogs
            Case "6"
                call AssociarAssinatura
            Case "7"    
                call AtualizarSoftwareSAT          
            Case "8"                
                call ConfigurarInterfaceDeRede
            Case "9"    
                call TrocarCodigoDeAtivacao               
            Case "q"    
                Exit Do               
            Case "Q"    
                Exit Do
            Case else
                stdout.WriteLine "opcao incorreta"
                stdout.WriteLine opcao
                opcao = "1"
        End Select
     Loop








